# OpenRA

A Libre/Free Real Time Strategy game engine supporting early Westwood classics.

* Website: [http://www.open-ra.org](http://www.open-ra.org)
* IRC: \#openra on irc.freenode.net
* Repository: [https://github.com/openra/openra](https://github.com/openra/openra) [![Build Status](https://travis-ci.org/OpenRA/OpenRA.png?branch=bleed)](https://travis-ci.org/OpenRA/OpenRA)

Please read the [FAQ](https://github.com/OpenRA/OpenRA/wiki/FAQ) in our [Wiki](https://github.com/OpenRA/OpenRA/wiki) and report problems at [http://bugs.open-ra.org](http://bugs.open-ra.org).

Join the [Forums](http://www.sleipnirstuff.com/forum/viewforum.php?f=80) for discussion.

## Play

Distributed mods include a reimagining of
* Command & Conquer: Red Alert
* Command & Conquer: Tiberian Dawn
* Dune 2000

Check our [Playing the Game](https://github.com/OpenRA/OpenRA/wiki/Playing-the-game) Guide to win multiplayer matches.

## Contribute

* Please read [INSTALL](https://github.com/OpenRA/OpenRA/blob/bleed/INSTALL) and [Compiling](https://github.com/OpenRA/OpenRA/wiki/Compiling) on how to set up an OpenRA development environment.
* See [Hacking](https://github.com/OpenRA/OpenRA/wiki/Hacking) for an overview of the engine.
* To get your patches merged, please adhere to the [Contributing](https://github.com/OpenRA/OpenRA/blob/bleed/CONTRIBUTING.md) guidelines.

## Mapping

* We offer a [Mapping](https://github.com/OpenRA/OpenRA/wiki/Mapping) Tutorial as you can change gameplay drastically with custom maps.
* If you want to share your maps, mini-games and units with the community, upload them at [http://content.open-ra.org](http://content.open-ra.org).

## Modding

* There exists an auto-generated [Trait documentation](https://github.com/OpenRA/OpenRA/wiki/Traits) to get started with yaml files.
* Check the [Modding Guide](https://github.com/OpenRA/OpenRA/wiki/Modding%20Guide) to create your own classic RTS.
* Some hints on how to create new OpenRA compatible [Pixelart](https://github.com/OpenRA/OpenRA/wiki/Pixelart).
* Upload total conversions at [our ModDB profile](http://www.moddb.com/games/openra/mods).

## Support

* Sponsor a [mirror server](https://github.com/OpenRA/OpenRAWeb/tree/master/content/packages) if you have some bandwidth to spare.
* You can immediately set up a [Dedicated](https://github.com/OpenRA/OpenRA/wiki/Dedicated) Game Server.
* Fund development by creating [Bounties](https://www.bountysource.com/trackers/36085-openra) on specific tasks.
